> For the complete documentation index, see [llms.txt](https://docs.fulfillmenttools.com/documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fulfillmenttools.com/documentation/apis/customer-defined-ids-in-requests.md).

# Customer-defined IDs in requests

fulfillmenttools allows specifying a customer-defined ID for certain entities. The ID format follows the pattern `tenant{ENTITY}Id`. This field allows for transferring IDs from external systems to the fulfillmenttools. If this ID is unambiguous, it enables reading and writing the entity using HTTP.

Currently, this functionality applies only to stock entities.

{% hint style="info" %}
For information on retrieving entities by their `tenant{ENTITY}Id` using a path parameter, refer to the [Uniform Resource Name (URN) pattern in path parameters](/documentation/apis/api-reference.md#uniform-resource-name-pattern-urn-in-path-parameters) documentation.
{% endhint %}

## Examples for stock

### Get stock with a user-defined ID

```http
GET https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks?tenantFacilityId=CGN-01
```

### Search for stock with a user-defined ID

```http
POST https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks/search
```

{% code title="Request body (JSON)" %}

```json
{
    "query": {
        "tenantFacilityId": {
            "eq": "CGN-01"
        }
    }
}
```

{% endcode %}

### Create stock with a user-defined ID via PUT

```http
PUT https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks
```

{% code title="Request body (JSON)" %}

```json
{
    "stocks": [
        {
            "facility": {
                "tenantFacilityId": "CGN-01"
            },
            "tenantArticleId": "0188104",
            "value": 100
        }
    ]
}
```

{% endcode %}

### Create a stock with a user-defined ID via POST

```http
POST https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks
```

{% code title="Request body (JSON)" %}

```json
{
    "facility": {
        "tenantFacilityId": "CGN-01"
    },
    "tenantArticleId": "0188104",
    "value": 101
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fulfillmenttools.com/documentation/apis/customer-defined-ids-in-requests.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
